using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
//using Syncfusion.Grouping;

namespace SampleForSyncfusion
{
	/// <summary>
	/// Hi - There are two problems that I'm having with this code. 
	/// 1/ The horizontal scroll bar disappears
	/// 2/ If you click in a cell and then press the right arrow to scroll the grid to the right,
	/// the data 'disappears'. I thought that it might be because I had null values in my app... 
	/// however, when I simplified the code to the below (where I can be assuered that there aren't
	/// any nulls) I still see the same behaviour. 
	/// 
	/// Please note that the below code is a very simplified version of our application. In our app, 
	/// the properties of the classes represented by clsTempObject all have custom attributes on them. 
	/// They are added/excluded to the grid based on properties of these attributes set at runtime. 
	/// 
	/// Thanks very much in advance for your help. I really need to get to the bottom of this one.. 
	/// 
	/// Please note - we are using Essential Suite 2.0.5.0
	/// 
	/// 
	/// Damien Sawyer
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gr1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			LoadGrid();
		}

		public void LoadGrid()
		{
			Type TargetType = typeof(clsTempObject);

			ArrayList Columns = new ArrayList();
			
			this.gr1.ShowGroupDropArea = true;
			this.gr1.TopLevelGroupOptions.ShowCaption = false;
			this.gr1.TableDescriptor.AllowCalculateMaxColumnWidth = false;

			foreach (PropertyInfo pi in TargetType.GetProperties())
			{
				Columns.Add(pi);
			}


			foreach (PropertyInfo pi2 in Columns)
			{
				GridColumnDescriptor gcd = new GridColumnDescriptor(pi2.Name,
					pi2.Name,
					pi2.Name,
					false,
					50);
			gcd.HeaderText = pi2.Name;
				this.gr1.TableDescriptor.Columns.Add(gcd);
				gcd.Width = 200;
			}

			/* the following code causes the scrollbar to appear, however 
			 * it is 'disabled'...
			 */
			this.gr1.TableControl.HScrollBehavior = GridScrollbarMode.Enabled; 

			// Add some data
			ArrayList SampleData = new ArrayList();
			for (int i = 0 ; i<100; i++)
			{
				SampleData.Add(new clsTempObject());
			}
			this.gr1.DataSource = SampleData;
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gr1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gr1)).BeginInit();
			this.SuspendLayout();
			// 
			// gr1
			// 
			this.gr1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gr1.BackColor = System.Drawing.SystemColors.Window;
			this.gr1.Location = new System.Drawing.Point(8, 8);
			this.gr1.Name = "gr1";
			this.gr1.Size = new System.Drawing.Size(736, 432);
			this.gr1.TabIndex = 0;
			this.gr1.TableDescriptor.Name = "Default";
			this.gr1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(752, 446);
			this.Controls.Add(this.gr1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gr1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
